#include "disa8255lab.h"  
#include <sys/ioctl.h>  /* ioctl */


int WriteIsa8255LabCounter(int file_desc, int number,int value)
{
  int ret_val;
  if((number<COUNTER1)||(number>COUNTER3)) return -1;
  ret_val = ioctl(file_desc, DISA8255LAB_SET_REGISTER, number);
  ret_val = ioctl(file_desc, DISA8255LAB_WRITE_COUNTER, value);
  return ret_val;
}

int ReadIsa8255LabCounter(int file_desc, int number)
{
  int ret_val=0;
  if((number<COUNTER1)||(number>COUNTER3)) return -1;
  ioctl(file_desc, DISA8255LAB_SET_REGISTER, number);
  ioctl(file_desc, DISA8255LAB_READ_COUNTER, &ret_val);
  return ret_val;
}

int WriteIsa8255LabPort(int file_desc, int port,char value)
{
  int ret_val;
  if((port<0)||(port>PORTC2)) return -1;
  ret_val = ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ret_val = ioctl(file_desc, DISA8255LAB_WRITE_PORT, value);
  return ret_val;
}

unsigned char ReadIsa8255LabPort(int file_desc, int port)
{
  unsigned char ret_val=0;
  if((port<0)||(port>PORTC2)) return -1;
  ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ioctl(file_desc, DISA8255LAB_READ_PORT, &ret_val);
  return ret_val;
}

int WriteIsa8255LabControlWord(int file_desc, int port, char value)
{
 int ret_val;
  ret_val = ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ret_val = ioctl(file_desc, DISA8255LAB_SET_CONTROLWORD, value);
  return ret_val;
}

unsigned char ReadIsa8255LabControlWord(int file_desc, int port)
{
  unsigned char ret_val=0;
  if((port<0)||(port>CONTROLWORD3)) return -1;
  ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ioctl(file_desc, DISA8255LAB_GET_CONTROLWORD, &ret_val);
  return (~ret_val);
}
